/* This is "compare2.c", written to accompany Introduction to
   Scientific Programming by Joseph L. Zachary. */

/* Together with "integ2.c" and "integ.h", this is an
   implementation and a test driver for the rectangular and
   trapezoidal methods of numerical integration. */


#include <stdio.h>
#include <math.h>
#include "integ.h"



/* Returns sin(x)+2. */

double f (double x)
{
  return(sin(x) + 2);
}



/* Test driver for "rectangular" and "trapezoidal". */

void main (void)
{

  int ndivisions;
  double low, high;

  printf("Enter number of divisions: ");
  scanf("%d", &ndivisions);

  printf("Enter low bound of integration: ");
  scanf("%lf", &low);

  printf("Enter high bound of integration: ");
  scanf("%lf", &high);

  printf("Rectangular = %g, trapezoidal = %g\n",
         rectangular(low, high, ndivisions, f),
         trapezoidal(low, high, ndivisions, f));

}
