/* This is "newton7.c", written to accompany Introduction to
   Scientific Programming by Joseph L. Zachary. */

/* This program is a COMPLETELY INCORRECT implementation and
   test driver for Newton's method with complex numbers as
   described in Chapter 16 of the text.  It is incorrect because
   it tries to manipulate values of type "complex" using
   the floating-point operators and conversion specifications. */


#include <stdio.h>
#include <math.h>



/* This structure is designed to represent complex numbers. */

typedef struct {
  double real;      /* Real component of complex number */
  double imag;      /* Imaginary component of complex number */
} complex;



/* This is x^2 - 6x + 13, whose root we seek.  IT IS
   COMPLETELY INCORRECT! */

complex f (complex x)
{
  return(x*x - 6*x + 13);
}



/* This is 2x - 6, which is the first derivative of f.  IT IS
   COMPLETELY INCORRECT! */

complex fprime (complex x)
{
  return(2*x - 6);
}



/* An implementation of Newton's method that finds complex roots.
   It improves the guess "g0" for the root of "f" until the absolute
   value of the difference between two successive guesses becomes
   small relative to the first of the two guesses.  It then returns
   the improved guess.  IT IS COMPLETELY INCORRECT! */

complex newton (complex g0)
{
  complex oldg0;
  do {
    oldg0 = g0;
    g0 = g0 - f(g0)/fprime(g0);
  }
  while (fabs((g0-oldg0) / g0) > 1e-10);
  return(g0);
}



/* A test driver that uses "newton" to find a complex root of "f"
   given a guess read from the keyboard.  IT IS COMPLETELY
   INCORRECT! */

void main (void)
{
  complex guess, root;
  printf("Please enter an initial guess: ");
  scanf("%lf", &guess);
  root = newton(guess);
  printf("An approximate root is %g\n", guess);
}
